<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="实验室id" prop="subjectId">
        <el-input
          v-model="queryParams.subjectId"
          placeholder="请输入实验室id"
          clearable
          size="small"
        />
      </el-form-item>
      <el-form-item label="安全准日配置id" prop="groupconfigureId">
        <el-input
          v-model="queryParams.groupconfigureId"
          placeholder="请输入安全准日配置id"
          clearable
          size="small"
        />
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
          v-hasPermi="['laboratory:securityconfigure:add']"
        >新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="success"
          plain
          icon="el-icon-edit"
          size="mini"
          :disabled="single"
          @click="handleUpdate"
          v-hasPermi="['laboratory:securityconfigure:edit']"
        >修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="el-icon-delete"
          size="mini"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['laboratory:securityconfigure:remove']"
        >删除</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="warning"
          plain
          icon="el-icon-download"
          size="mini"
          @click="handleExport"
          v-hasPermi="['laboratory:securityconfigure:export']"
        >导出</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" border :data="securityconfigureList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="主键id" align="left" prop="id" />
      <el-table-column label="实验室id" align="left" prop="subjectId" />
      <el-table-column label="安全准日配置id" align="left" prop="groupconfigureId" />
      <el-table-column label="备注" align="left" prop="remark" />
      <el-table-column label="操作" align="left" class-name="small-padding fixed-width" v-if="tableButtonType">
        <template slot-scope="scope">
          <div class="table-button-box">
            <p class="table-button-null"></p>
            <p class="table-button-p"
               @click="handleUpdate(scope.row)"
               v-hasPermi="['laboratory:securityconfigure:edit']">修改</p>
            <p class="table-button-p"
               @click="handleDelete(scope.row)"
               v-hasPermi="['laboratory:securityconfigure:remove']">删除</p>
            <p class="table-button-null"></p>
          </div>
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      layout="total, prev, pager, next, sizes, jumper"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改实验室和安全准入配置中间关联对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="500px" append-to-body
               :close-on-click-modal="false">
      <el-form ref="form" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="实验室id" prop="subjectId">
          <el-input v-model="form.subjectId" placeholder="请输入实验室id" />
        </el-form-item>
        <el-form-item label="安全准日配置id" prop="groupconfigureId">
          <el-input v-model="form.groupconfigureId" placeholder="请输入安全准日配置id" />
        </el-form-item>
        <el-form-item label="备注" prop="remark">
          <el-input v-model="form.remark" placeholder="请输入备注" />
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button @click="cancel">取 消</el-button>
        <el-button type="primary" @click="submitForm">确 定</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import { listSecurityconfigure, getSecurityconfigure, delSecurityconfigure, addSecurityconfigure, updateSecurityconfigure } from "@/api/laboratory/securityconfigure";

export default {
  name: "Securityconfigure",
  data() {
    return {
      tableButtonType:this.hasPermiDom(['laboratory:securityconfigure:edit','laboratory:securityconfigure:remove']),
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 实验室和安全准入配置中间关联表格数据
      securityconfigureList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize:20,
        subjectId: null,
        groupconfigureId: null,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
      }
    };
  },
  created() {
    this.getList();
  },
  methods: {
    /** 查询实验室和安全准入配置中间关联列表 */
    getList() {
      this.loading = true;
      listSecurityconfigure(this.queryParams).then( response => {
        this.securityconfigureList =  response.rows;
        this.total =  response.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        subjectId: null,
        groupconfigureId: null,
        remark: null
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加实验室和安全准入配置中间关联";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id || this.ids
      getSecurityconfigure(id).then( response => {
        this.form =  response.data;
        this.open = true;
        this.title = "修改实验室和安全准入配置中间关联";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.id != null) {
            updateSecurityconfigure(this.form).then( response => {
              this.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addSecurityconfigure(this.form).then( response => {
              this.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$confirm('是否确认删除实验室和安全准入配置中间关联?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(function() {
          return delSecurityconfigure(ids);
        }).then(() => {
          this.getList();
          this.msgSuccess("删除成功");
        }).catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      this.download('laboratory/securityconfigure/export', {
        ...this.queryParams
      }, `laboratory_securityconfigure.xlsx`)
    }
  }
};
</script>
